import{jsx as _jsx,jsxs as _jsxs,Fragment as _Fragment}from"react/jsx-runtime";import{useState,useEffect}from"react";import{auth}from"../firebaseConfig";import{onAuthStateChanged,signOut}from"firebase/auth";import{signInWithEmailAndPassword,createUserWithEmailAndPassword}from"firebase/auth";import{Button,Box,TextField,Popper,Typography}from"@mui/material";import LogoutIcon from"@mui/icons-material/Logout";function Login(){const[formToShow,setFormToShow]=useState("none");const[email,setEmail]=useState("");const[password,setPassword]=useState("");const[errorMessage,setErrorMessage]=useState("");const[anchorEl,setAnchorEl]=useState(null);const[user,setUser]=useState(null);useEffect(()=>{const unsubscribe=onAuthStateChanged(auth,user=>{setUser(user);setEmail("");setPassword("");setErrorMessage("")});return()=>unsubscribe()},[]);const signIn=async()=>{setFormToShow("none");setAnchorEl(null);try{await signInWithEmailAndPassword(auth,email,password);console.log("User signed in successfully.")}catch(error){if(error instanceof Error){const firebaseError=error;switch(firebaseError.code){case"auth/wrong-password":setErrorMessage("Wrong password.");break;case"auth/user-not-found":setErrorMessage("User not found.");break;default:setErrorMessage("Unknown error.")}console.log(firebaseError.code,firebaseError.message)}}};const signUp=async()=>{setFormToShow("none");setAnchorEl(null);try{console.log(email,password);await createUserWithEmailAndPassword(auth,email,password);console.log("User signed up successfully.")}catch(error){if(error instanceof Error){const firebaseError=error;console.log(email,password);switch(firebaseError.code){case"auth/email-already-in-use":setErrorMessage("Email already in use.");break;case"auth/weak-password":setErrorMessage("Weak password (6 characters).");break;case"auth/invalid-email":setErrorMessage("Invalid email.");break;case"auth/invalid-credential":setErrorMessage("Wrong password.");break;default:setErrorMessage("S'ha produït un error desconegut.")}console.log(firebaseError.code,firebaseError.message)}}};const logout=async()=>{try{await signOut(auth);console.log("User signed out successfully.")}catch(error){console.log("Error signing out:",error)}};const toggleLoginForm=event=>{setAnchorEl(event.currentTarget);setFormToShow(formToShow==="login"?"none":"login")};const toggleSignUpForm=event=>{setAnchorEl(event.currentTarget);setFormToShow(formToShow==="signup"?"none":"signup")};return _jsxs(_Fragment,{children:[!user?_jsxs(_Fragment,{children:[_jsx(Button,{color:"inherit",onClick:toggleLoginForm,children:"Login"}),_jsxs(Button,{color:"inherit",onClick:toggleSignUpForm,sx:{lineHeight:1.3},children:["Create ",_jsx("br",{})," Account"]})]}):_jsxs(Box,{gap:2,sx:{display:"flex",flexDirection:"row"},children:[_jsx("p",{children:user.email}),_jsx(Button,{children:_jsx(LogoutIcon,{onClick:logout})})]}),_jsxs(Popper,{open:formToShow==="login"||formToShow==="signup",anchorEl:anchorEl,placement:"bottom-end",sx:{boxShadow:5,padding:"40px",width:"340px",backgroundColor:"white"},children:[_jsxs(Box,{component:"form",sx:{backgroundColor:"white",width:"100%",display:"flex",flexDirection:"column",padding:0,gap:2},padding:5,children:[_jsx(TextField,{required:true,id:"email_login",label:"Email",value:email,onChange:e=>setEmail(e.target.value)}),_jsx(TextField,{required:true,id:"password_login",label:"Password",type:"password",value:password,onChange:e=>setPassword(e.target.value)})]}),formToShow==="login"&&_jsx(Button,{onClick:signIn,children:"Sign In"}),formToShow==="signup"&&_jsx(Button,{onClick:signUp,children:"Create Account"}),_jsx(Typography,{children:errorMessage})]})]})}export{Login,auth};